Subject: [ippm] Comments on draft-ietf-ippm-explicit-flow-measurements-00

From: Ike Kunze <[email-masked]>
Date: Fri, 18 Mar 2022 15:48:46 +0000

Hi all,

in my mail supporting adoption of the efm draft, I mentioned that "the descriptions of the approaches could be a bit more precise”.
In the past weeks, I have discussed these aspects with Mauro, Massimo, and Fabio and would like to quickly summarize my main “concerns” here so that (hopefully) everyone can profit.

R-Bit:
To me, the exact behavior when updating the R block length if a new Q block has been completed during the R block transmission is not entirely clear.
While the text on this is technically correct, I believe that it could be beneficial to explicitly describe the behavior, e.g., when the new R block length is shorter than the previous one.

T-Bit:
I believe that the description of the T-Bit could profit from a more detailed presentation of two aspects:

First, I misinterpreted that the generation token counter is reset each time a new generation phase starts.
This then led to several additional false inferences.
Consequently, I think that the description of the concrete behavior of the generation token counter could be more precise.

Second, the concrete choice of “2 spin bit periods” for the T-Bit phases (in connection with the misinterpretation of the generation token counter) again led to
several false inferences on my part.
Thus, I think that some discussion on why this phase length is chosen might be beneficial to avoid such misinformed reasoning.

Additionally, the T-Bit algorithm is currently presented once at a semi-high-level at the start of Section 4.1 and then again in Section 4.1.2.
This made me jump between the sections several times as it is not obvious which part contains which information.
My suggestion would be to either (i) merge the two parts or to (ii) make the description at the start of 4.1 more general so that it is clear that it is only intended as a rough overview and not as potentially containing critical implementation aspects.
That could help so that all information is found in one place and one place only.

General comment:
In addition to these aspects directly concerning two of the mechanisms, I also have a more high-level proposal regarding the structure of the loss bit section.
In Section 4, the combination of L+Q comes as Section 4.4. after the T, Q and L Bits have been presented.
The R-Bit is then presented in Sec 4.5 and the combination of R+Q in subsection of 4.5.1.
I think it would be cleaner if all of the loss bits would be presented first.
The different possible combinations could then be presented in a joint Section 4.5.
In my opinion, this would make it easier to fully grasp the different possible combinations and, especially, allow for a sensible comparison between the possibilities.

Hope this helps!
Cheers,
Ike